summaryrefslogtreecommitdiff
path: root/plugins/emacs/emacsclient.sh
diff options
context:
space:
mode:
authorTuowen Zhao <ztuowen@gmail.com>2021-10-23 18:01:40 -0600
committerTuowen Zhao <ztuowen@gmail.com>2021-10-23 18:01:40 -0600
commitfad92c603be0ff36825cc53bf8c485d4b95c7869 (patch)
tree407fe826be62a3543b6feab4f3552f58575234de /plugins/emacs/emacsclient.sh
parentc674485e6b4abe313469900997d893d2940ee843 (diff)
parentf1dd97bb2a9df55fae9b1ca26c829b9f8b290667 (diff)
downloadzsh-fad92c603be0ff36825cc53bf8c485d4b95c7869.tar.gz
zsh-fad92c603be0ff36825cc53bf8c485d4b95c7869.tar.bz2
zsh-fad92c603be0ff36825cc53bf8c485d4b95c7869.zip
Merge remote-tracking branch 'origin/master'
Diffstat (limited to 'plugins/emacs/emacsclient.sh')
-rwxr-xr-xplugins/emacs/emacsclient.sh51
1 files changed, 30 insertions, 21 deletions
diff --git a/plugins/emacs/emacsclient.sh b/plugins/emacs/emacsclient.sh
index 04a2c2afd..25efe0d68 100755
--- a/plugins/emacs/emacsclient.sh
+++ b/plugins/emacs/emacsclient.sh
@@ -1,29 +1,38 @@
#!/bin/sh
-_emacsfun()
-{
- # get list of emacs frames.
- frameslist=`emacsclient --alternate-editor '' --eval '(frame-list)' 2>/dev/null | egrep -o '(frame)+'`
+emacsfun() {
+ local cmd frames
- if [ "$(echo "$frameslist" | sed -n '$=')" -ge 2 ] ;then
- # prevent creating another X frame if there is at least one present.
- emacsclient --alternate-editor "" "$@"
- else
- # Create one if there is no X window yet.
- emacsclient --alternate-editor "" --create-frame "$@"
- fi
-}
+ # Build the Emacs Lisp command to check for suitable frames
+ # See https://www.gnu.org/software/emacs/manual/html_node/elisp/Frames.html#index-framep
+ case "$*" in
+ *-t*|*--tty*|*-nw*) cmd="(memq 't (mapcar 'framep (frame-list)))" ;; # if != nil, there are tty frames
+ *) cmd="(delete 't (mapcar 'framep (frame-list)))" ;; # if != nil, there are graphical terminals (x, w32, ns)
+ esac
+
+ # Check if there are suitable frames
+ frames="$(emacsclient -a '' -n -e "$cmd" 2>/dev/null)"
+ # Only create another X frame if there isn't one present
+ if [ -z "$frames" -o "$frames" = nil ]; then
+ emacsclient --alternate-editor "" --create-frame "$@"
+ return $?
+ fi
-# adopted from https://github.com/davidshepherd7/emacs-read-stdin/blob/master/emacs-read-stdin.sh
+ emacsclient --alternate-editor "" "$@"
+}
+
+# Adapted from https://github.com/davidshepherd7/emacs-read-stdin/blob/master/emacs-read-stdin.sh
# If the second argument is - then write stdin to a tempfile and open the
# tempfile. (first argument will be `--no-wait` passed in by the plugin.zsh)
-if [ "$#" -ge "2" -a "$2" = "-" ]
-then
- tempfile="$(mktemp --tmpdir emacs-stdin-$USERNAME.XXXXXXX 2>/dev/null \
- || mktemp -t emacs-stdin-$USERNAME)" # support BSD mktemp
- cat - > "$tempfile"
- _emacsfun --no-wait $tempfile
-else
- _emacsfun "$@"
+if [ $# -ge 2 -a "$2" = "-" ]; then
+ # Create a tempfile to hold stdin
+ tempfile="$(mktemp --tmpdir emacs-stdin-$USERNAME.XXXXXXX 2>/dev/null \
+ || mktemp -t emacs-stdin-$USERNAME)" # support BSD mktemp
+ # Redirect stdin to the tempfile
+ cat - > "$tempfile"
+ # Reset $2 to the tempfile so that "$@" works as expected
+ set -- "$1" "$tempfile" "${@:3}"
fi
+
+emacsfun "$@"